"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _babelPluginSyntaxFlow = _interopRequireDefault(require("babel-plugin-syntax-flow"));

var t = _interopRequireWildcard(require("babel-types"));

var _babelAddFlowComments = _interopRequireDefault(require("babel-add-flow-comments"));

var _globby = _interopRequireDefault(require("globby"));

var _uppercamelcase = _interopRequireDefault(require("uppercamelcase"));

var _s2sUtils = require("s2s-utils");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const createInitAction = (0, _s2sUtils.template)(`export type ReduxInitAction = { type: '@@INIT' }`);

function createActionName(filename) {
  return `${(0, _uppercamelcase.default)((0, _s2sUtils.getParentDirName)(filename))}Action`;
}

var _default = () => {
  return {
    inherits: _babelPluginSyntaxFlow.default,
    name: 's2s-action-root',
    visitor: {
      Program: {
        // eslint-disable-next-line unicorn/prevent-abbreviations
        exit(programPath, {
          opts
        }) {
          const {
            input,
            output
          } = opts;

          const globOptions = _objectSpread({
            absolute: true
          }, opts.globOptions);

          if (!input) {
            throw new Error('require input option');
          }

          if (!output) {
            throw new Error('require output option');
          }

          const files = _globby.default.sync(input, globOptions);

          const imports = files.map(f => (0, _s2sUtils.typeImport)(createActionName(f), 'Action', (0, _s2sUtils.getImportPath)(output, f))); // export type Action = ...

          const exportTypeActionAst = t.exportNamedDeclaration(t.typeAlias(t.identifier('Action'), null, t.createUnionTypeAnnotation([t.genericTypeAnnotation(t.identifier('ReduxInitAction')), ...files.map(createActionName).map(name => t.genericTypeAnnotation(t.identifier(name)))])), []);
          programPath.node.body = [...imports, t.noop(), createInitAction(), t.noop(), exportTypeActionAst];
          (0, _babelAddFlowComments.default)(programPath);
        }

      }
    }
  };
};

exports.default = _default;